include MMFShare.inc
include ../CmnHdr.inc
;**********************CODE SEGMENT*********************************
.code 

start:;START PROG HERE.  
		invoke	InitCommonControls
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax
		invoke	DialogBoxParam,hInstance,IDD_MMFSHARE ,NULL,offset DlgProc,0
		invoke	ExitProcess,NULL

;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc	uses ebx edi esi, hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		.elseif	eax == WM_INITDIALOG
			invoke LoadIcon,hInstance,IDI_MMFSHARE
			push eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax		
			pop eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
			invoke SetDlgItemText,hWnd,IDC_DATA,SADD("Some test data")
			invoke GetDlgItem,hWnd,IDC_CLOSEFILE
			invoke EnableWindow,eax,FALSE
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			.if eax == IDCANCEL
				invoke	EndDialog,hWnd,NULL
			.elseif eax==IDC_CREATEFILE
				invoke CreateFileMapping,INVALID_HANDLE_VALUE,NULL,PAGE_READWRITE,0,4*1024,SADD("MMFSharedData")
				.if eax!=NULL
					mov s_hFileMap,eax
					invoke GetLastError
					.if eax== ERROR_ALREADY_EXISTS
						chMB SADD("Mapping already exists - not created.")
						invoke CloseHandle,s_hFileMap
					.else
					 ;File mapping created successfully.
                     ;Map a view of the file into the address space.
					 invoke MapViewOfFile,s_hFileMap,FILE_MAP_READ or  FILE_MAP_WRITE, 0, 0, 0
					 .if eax!=NULL
						mov pView,eax
						invoke GetDlgItemText,hWnd,IDC_DATA,eax,4*1024
						invoke UnmapViewOfFile,pView
						invoke GetDlgItem,hWnd,IDC_CREATEFILE
						invoke EnableWindow,eax,FALSE
						INVOKE GetDlgItem,hWnd,IDC_CLOSEFILE
						invoke EnableWindow,eax,TRUE
					 .else
						chMB SADD("Can't map view of file.")
					 .endif
					.endif
				.else
					chMB SADD("Can't create file mapping.")
				.endif
			.elseif eax==IDC_CLOSEFILE
				invoke CloseHandle,s_hFileMap
				.if eax!=NULL
					invoke GetDlgItem,hWnd,IDC_CREATEFILE
					invoke EnableWindow,eax,TRUE
					invoke GetDlgItem,hWnd,IDC_OPENFILE
					invoke EnableWindow,eax,TRUE
				.else	
				.endif
			.elseif eax==IDC_OPENFILE
				invoke OpenFileMapping,FILE_MAP_READ or  FILE_MAP_WRITE,FALSE,SADD("MMFSharedData")
				.if eax!=NULL
					mov hFileMap,eax
					invoke MapViewOfFile,eax,FILE_MAP_READ or  FILE_MAP_WRITE, 0, 0, 0
					.if eax!=NULL
						mov pView,eax
						invoke SetDlgItemText,hWnd,IDC_DATA,eax
						invoke UnmapViewOfFile,pView
					.else
						chMB SADD("Can't map view.")
					.endif
					invoke CloseHandle,hFileMap
				.else
					chMB SADD("Can't open mapping.")
				.endif
			
			.endif
		.else
			mov	eax,FALSE
			ret
		.endif		   
		mov	eax,TRUE
		ret
		
DlgProc	endp
;********************************************************************
end	start
